"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperationExecutionAgent = void 0;
const request_1 = require("./request");
class OperationExecutionAgent extends request_1.OperationExecutionRequestBuilder {
    constructor(execute) {
        super();
        this.execute = execute;
    }
    end() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.maybeExecutionResult === undefined) {
                this.maybeExecutionResult = this.execute(this.build(), this.executionContext);
            }
            return yield this.maybeExecutionResult;
        });
    }
    context(ctx) {
        this.executionContext = ctx;
        return this;
    }
    then(onfulfilled, onrejected) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.end().then(onfulfilled, onrejected);
        });
    }
    catch(onrejected) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.end().catch(onrejected);
        });
    }
    finally(onfinally) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.end().finally(onfinally);
        });
    }
}
exports.OperationExecutionAgent = OperationExecutionAgent;
Symbol.toStringTag;
//# sourceMappingURL=agent.js.map