import { OperationExecutionRequest } from 'executable-openapi-types';
export declare class OperationExecutionRequestBuilder {
    private request;
    get(path: string): this;
    put(path: string): this;
    post(path: string): this;
    delete(path: string): this;
    options(path: string): this;
    head(path: string): this;
    patch(path: string): this;
    trace(path: string): this;
    query(query: {
        [queryName: string]: string;
    }): this;
    send(content: unknown): this;
    send(mediaType: string, content: unknown): this;
    header(): never;
    cookie(): never;
    auth(securitySchemeName: string, scopes?: boolean | string[]): this;
    auth(securities: {
        [securitySchemeName: string]: boolean | string[];
    }): this;
    build(): OperationExecutionRequest;
}
