"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperationExecutionTestAgent = void 0;
const agent_1 = require("./agent");
class OperationExecutionTestAgent extends agent_1.OperationExecutionAgent {
    constructor() {
        super(...arguments);
        this.assertions = [];
    }
    expect(status) {
        this.assertions.push((res) => {
            if (res === null) {
                throw new Error(`Expected response with "${status}", got no response`);
            }
            if (res.status !== status) {
                throw new Error(`Expected "${status}", got "${res.status}"`);
            }
        });
        return this;
    }
    runAssertions(res) {
        for (const assertion of this.assertions) {
            assertion(res);
        }
    }
    end() {
        const _super = Object.create(null, {
            end: { get: () => super.end }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const res = yield _super.end.call(this);
            this.runAssertions(res);
            return res;
        });
    }
}
exports.OperationExecutionTestAgent = OperationExecutionTestAgent;
//# sourceMappingURL=test-agent.js.map